# Installation of Kerberos on Windows

In order to get firefox to work with the Pontus demo machine, we need to install the MIT kerberos distribution on Windows.  Here are the rough instructions on how to do it:

Download MIT Kerberos on Windows:
```
http://web.mit.edu/kerberos/dist/index.html#kfw-4.1
```

Run the installer, and create the following file on c:\Windows\krb5.ini:
```
[logging]
 default = FILE:krb5libs.log
 kdc = FILE:krb5kdc.log
 admin_server = FILE:kadmind.log
[libdefaults]
 default_realm = YOUR_REALM_GOES_HERE
 dns_lookup_realm = false
 dns_lookup_kdc = false
 ticket_lifetime = 30d
 renew_lifetime = 7d
 forwardable = true
 udp_preference_limit = 1
[realms]
 YOUR_REALM_GOES_HERE = {
  kdc = 10.8.0.1
  admin_server = 10.8.0.1
  }
[domain_realm]
 .YOUR_REALM_GOES_HERE = YOUR_REALM_GOES_HERE
 YOUR_REALM_GOES_HERE = YOUR_REALM_GOES_HERE
```
[Note] Note: if you don't have access to C:\Windows, it is possible to create this file elsewhere, and create the following environment variable:
```
KRB5_CONFIG=H:\Pontus-Sandbox\krb5.ini
```

Set the following environment variable to point to a suitable location of the Kerberos Cache (where the tickets are stored:
```
KRB5CCNAME=H:\Pontus-Sandbox\krbcache
```

Download openvpn client for windows:
```
https://openvpn.net/index.php/open-source/downloads.html
```
 
 Get the openvpn configuration file and keys from your administrator; here's an example that actually uses an ssh tunnel to the host machine with port forwarding for tcp/1194:
```
#-- Config Auto Generated By Viscosity --#

#viscosity startonopen false
#viscosity dhcp true
#viscosity dnssupport true
#viscosity name Pontus-POC-VPN
remote 127.0.0.1 1194 tcp-client
persist-key
tls-client
pull
ca ca.crt
dev tun
persist-tun
cert cert.crt
nobind
key key.key
link-mtu 1559
cipher AES-256-CBC
keysize 256
```

Run the openvpn client from the command line (as administrator):
```
bin\openvpn.exe --config config.conf
``` 
[NOTE] Note:  We are using the VPN on top of an SSH tunnel for even more security; here's a sample configuration on the openvpn server on the linux side:

```
[root@Leo5 openvpn]# cat /etc/openvpn/server.conf
ca ca.crt
cert server.crt
cipher AES-256-CBC
dev tun
dh dh2048.pem
group nobody
ifconfig-pool-persist ipp.txt
keepalive 10 120
persist-key
persist-tun
port 1194
proto tcp
server 10.8.0.0 255.255.255.0
status openvpn-status.log
user nobody
verb 3
```

Here's the command line for the vpn server:
```
/usr/sbin/openvpn --proto tcp-server --mode server --config /etc/openvpn/server.conf  --bind --port 1194
```
[Note] Note: Ensure that the ssh tunnel to the machine is forwarding port tcp/1194

 
Edit the C:\Windows\System32\Drivers\etc\hosts file, adding the internal IP address of the HOST of the sandbox:
```
10.8.0.1 sandbox.hortonworks.com
```
[NOTE] Note: This should only be reachable using the openvpn tunnel; if you run ipconfig on the sample host machine, you should use eth0's address:
```
[root@Leo5 redaction]# ifconfig
docker0: flags=4163<UP,BROADCAST,RUNNING,MULTICAST>  mtu 1500
        inet xxx.xxx.xxx.xxx  netmask 255.255.0.0  broadcast 0.0.0.0
        ether yy:yy:yy:yy:yy:yy  txqueuelen 0  (Ethernet)
        RX packets 6763209  bytes 4789840127 (4.4 GiB)
        RX errors 0  dropped 0  overruns 0  frame 0
        TX packets 6592078  bytes 22485326059 (20.9 GiB)
        TX errors 0  dropped 0 overruns 0  carrier 0  collisions 0

eth0: flags=4163<UP,BROADCAST,RUNNING,MULTICAST>  mtu 1500
        inet 10.0.0.8  netmask 255.255.255.0  broadcast 10.0.0.255
        inet6 fe80::222:48ff:fe01:3e6a  prefixlen 64  scopeid 0x20<link>
        ether 00:22:48:01:3e:6a  txqueuelen 1000  (Ethernet)
        RX packets 14841005  bytes 17158243884 (15.9 GiB)
        RX errors 0  dropped 1  overruns 0  frame 0
        TX packets 6611474  bytes 4789651228 (4.4 GiB)
        TX errors 0  dropped 0 overruns 0  carrier 0  collisions 0

lo: flags=73<UP,LOOPBACK,RUNNING>  mtu 65536
        inet 127.0.0.1  netmask 255.0.0.0
        inet6 ::1  prefixlen 128  scopeid 0x10<host>
        loop  txqueuelen 0  (Local Loopback)
        RX packets 12548002  bytes 28781966068 (26.8 GiB)
        RX errors 0  dropped 0  overruns 0  frame 0
        TX packets 12548002  bytes 28781966068 (26.8 GiB)
        TX errors 0  dropped 0 overruns 0  carrier 0  collisions 0

tun0: flags=4305<UP,POINTOPOINT,RUNNING,NOARP,MULTICAST>  mtu 1500
        inet 10.8.0.1  netmask 255.255.255.255  destination 10.8.0.2
        unspec 00-00-00-00-00-00-00-00-00-00-00-00-00-00-00-00  txqueuelen 100  (UNSPEC)
        RX packets 2759  bytes 684524 (668.4 KiB)
        RX errors 0  dropped 0  overruns 0  frame 0
        TX packets 2763  bytes 679860 (663.9 KiB)
        TX errors 0  dropped 0 overruns 0  carrier 0  collisions 0

vethefa17ac: flags=4163<UP,BROADCAST,RUNNING,MULTICAST>  mtu 1500
        inet6 1234::1234:1234:1234:1234  prefixlen 64  scopeid 0x20<link>
        ether aa:bb:cc:dd:ee:ff  txqueuelen 0  (Ethernet)
        RX packets 2146120  bytes 376546379 (359.1 MiB)
        RX errors 0  dropped 0  overruns 0  frame 0
        TX packets 2154266  bytes 13988425468 (13.0 GiB)
        TX errors 0  dropped 0 overruns 0  carrier 0  collisions 0


```

 
